=== debian/changelog ===
charls (2.3.2+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2.3.2+dfsg

 -- Mathieu Malaterre <malat@debian.org>  Mon, 31 Jan 2022 13:40:42 +0100
