=== debian/control ===
Source: charls
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Shayan Doust <hello@shayandoust.me>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13)
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/med-team/charls
Vcs-Git: https://salsa.debian.org/med-team/charls.git
Homepage: https://github.com/team-charls/charls
Rules-Requires-Root: no

Package: libcharls-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libcharls2 (= ${binary:Version}),
         ${misc:Depends}
Breaks: libdcmtk-dev (<< 3.6.5-1~)
Replaces: libdcmtk-dev (<< 3.6.5-1~)
Description: Implementation of the JPEG-LS standard (development libraries)
 CharLS is an optimized implementation of the JPEG-LS standard for lossless and
 near-lossless image compression
 .
 JPEG-LS (ISO-14495-1/ITU-T.87) is a standard derived from the Hewlett Packard
 LOCO algorithm. JPEG LS has low complexity (meaning fast compression) and high
 compression ratios, similar to JPEG 2000. JPEG-LS is more similar to the old
 Lossless JPEG than to JPEG 2000, but interestingly the two different techniques
 result in vastly different performance characteristics.
 .
 This package contains the development files.

Package: libcharls2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Implementation of the JPEG-LS standard
 CharLS is an optimized implementation of the JPEG-LS standard for lossless and
 near-lossless image compression
 .
 JPEG-LS (ISO-14495-1/ITU-T.87) is a standard derived from the Hewlett Packard
 LOCO algorithm. JPEG LS has low complexity (meaning fast compression) and high
 compression ratios, similar to JPEG 2000. JPEG-LS is more similar to the old
 Lossless JPEG than to JPEG 2000, but interestingly the two different techniques
 result in vastly different performance characteristics.
