=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DPKG_GENSYMBOLS_CHECK_LEVEL = 4

# SAMPLES should not be installed:
# https://github.com/team-charls/charls/blob/master/samples/README.md
CMAKE_EXTRA_FLAGS += \
 -DBUILD_SHARED_LIBS:BOOL=ON \
 -DCHARLS_BUILD_SAMPLES:BOOL=ON \
 -DCHARLS_BUILD_TESTS:BOOL=ON \
 -DCHARLS_PEDANTIC_WARNINGS:BOOL=ON

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

pkg_run = libcharls2
pkg_dev = libcharls-dev

override_dh_install-arch:
	# Runtime Package
	dh_install -p$(pkg_run) usr/lib/$(DEB_HOST_MULTIARCH)/lib*.so.*
	# Development Package
	dh_install -p$(pkg_dev) usr/include
	dh_install -p$(pkg_dev) usr/lib/$(DEB_HOST_MULTIARCH)/lib*.so
	dh_install -p$(pkg_dev) usr/lib/$(DEB_HOST_MULTIARCH)/cmake/charls/*.cmake
	dh_install -p$(pkg_dev) usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/charls.pc
	# See #971425, #971431 & #971435:
	dh_link -p$(pkg_run) usr/lib/$(DEB_HOST_MULTIARCH)/libcharls.so.2 usr/lib/$(DEB_HOST_MULTIARCH)/libCharLS.so.2
	dh_link -p$(pkg_dev) usr/lib/$(DEB_HOST_MULTIARCH)/libcharls.so usr/lib/$(DEB_HOST_MULTIARCH)/libCharLS.so
	dh_link -p$(pkg_dev) usr/include/charls usr/include/CharLS
#	dh_install -a
#	d-shlibmove --commit \
#		     --multiarch \
#		     --devunversioned \
#		     --movedev debian/tmp/usr/include/* usr/include \
#		     debian/tmp/usr/lib/*/*.so
