## charls 2.3.3+dfsg

=== debian/changelog ===
charls (2.3.3+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2.3.3+dfsg. Closes: #1004842

 -- Mathieu Malaterre <malat@debian.org>  Mon, 07 Feb 2022 09:26:50 +0100
