## charls 2.3.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -210,7 +210,15 @@
 include(src/CMakeLists.txt)
 
 if(CHARLS_BUILD_TESTS)
+  enable_testing()
   add_subdirectory(test)
+
+  # The unit tests project depends on the VS C++ unit test framework. Use the -unittest option of the charlstest tool for other platforms.
+  add_test(
+    NAME basic-test
+    COMMAND charlstest -unittest
+    WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
+  )
 endif()
 
 if(CHARLS_BUILD_FUZZ_TEST)
