=== debian/changelog ===
charls (2.3.4-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2.3.4
  * d/copyright: Include all binary files from upstream
  * d/rules: Make sure to check return code of test

 -- Mathieu Malaterre <malat@debian.org>  Thu, 17 Feb 2022 09:11:23 +0100
