## charls 2.4.1

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -25,9 +25,14 @@
   target_compile_definitions(charls PUBLIC CHARLS_STATIC)
 endif()
 
+# Use different DLL filenames on Windows. It allows platform neutral adapters to load dynamicly the correct version.
 if(WIN32 AND BUILD_SHARED_LIBS)
   if(CMAKE_SIZEOF_VOID_P EQUAL 8)
-    set_target_properties(charls PROPERTIES OUTPUT_NAME "charls-2-x64")
+    if(CMAKE_CXX_COMPILER_ARCHITECTURE_ID MATCHES "ARM64")
+      set_target_properties(charls PROPERTIES OUTPUT_NAME "charls-2-arm64")
+    else()
+      set_target_properties(charls PROPERTIES OUTPUT_NAME "charls-2-x64")
+    endif()
   else()
     set_target_properties(charls PROPERTIES OUTPUT_NAME "charls-2-x86")
   endif()
@@ -59,6 +64,7 @@
     "include/charls/charls_jpegls_encoder.h"
     "include/charls/jpegls_error.h"
     "include/charls/public_types.h"
+    "include/charls/validate_spiff_header.h"
     "include/charls/version.h"
 )
 foreach(header HEADERS)
@@ -106,6 +112,7 @@
     "${CMAKE_CURRENT_LIST_DIR}/process_line.h"
     "${CMAKE_CURRENT_LIST_DIR}/scan.h"
     "${CMAKE_CURRENT_LIST_DIR}/util.h"
+    "${CMAKE_CURRENT_LIST_DIR}/validate_spiff_header.cpp"
     "${CMAKE_CURRENT_LIST_DIR}/version.cpp"
 )
