=== debian/changelog ===
charls (2.4.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2.4.1
  * d/symbols: Add new symbols

 -- Mathieu Malaterre <malat@debian.org>  Thu, 19 Jan 2023 16:14:14 +0100

charls (2.3.4-2) unstable; urgency=medium

  * Fix watch file
  * Standards-Version: 4.6.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Tue, 06 Dec 2022 18:06:56 +0100
