=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Priority: optional
 Build-Depends: cmake,
                debhelper-compat (= 13)
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/med-team/charls
 Vcs-Git: https://salsa.debian.org/med-team/charls.git
 Homepage: https://github.com/team-charls/charls
