=== debian/rules ===
--- 
+++ 
@@ -21,7 +21,7 @@
 	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)
 
 override_dh_auto_test-arch:
-	dh_auto_test || true
+	dh_auto_test
 
 pkg_run = libcharls2
 pkg_dev = libcharls-dev
