=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=auto,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
   https://github.com/team-charls/charls/tags .*/([\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)
