## charls 2.4.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # Copyright (c) Team CharLS.
 # SPDX-License-Identifier: BSD-3-Clause
 
-cmake_minimum_required(VERSION 3.13...3.22)
+cmake_minimum_required(VERSION 3.13...3.25)
 
 # Extract the version info from version.h
 file(READ "include/charls/version.h" version)
@@ -72,6 +72,7 @@
     -Wsized-deallocation
     -Wattributes
     -Wuseless-cast
+    -Wconversion
   )
   if(NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 6.0)
       set(PEDANTIC_CXX_COMPILE_FLAGS ${PEDANTIC_CXX_COMPILE_FLAGS}
@@ -113,6 +114,7 @@
       -Wthread-safety
       -Wthread-safety-beta
       -Wcomma
+      -Wconversion
       # -Weverything provides the option to discover usefull Clang warnings.
       # The list below ignores not useful Weverything warnings.
       -Wno-weak-vtables                       # Ignore, linker will remove the couple of extra vtables.
