=== samples/CMakeLists.txt ===
# Copyright (c) Team CharLS.
# SPDX-License-Identifier: BSD-3-Clause

add_subdirectory(convert.c)
add_subdirectory(convert.cpp)
