=== debian/changelog ===
charls (2.4.2-2build2) noble; urgency=medium

  * No change rebuild for frame pointers (and time_t).

 -- Matthias Klose <doko@ubuntu.com>  Fri, 19 Apr 2024 20:14:52 +0200

charls (2.4.2-2build1) noble; urgency=high

  * No change rebuild for frame pointers (and time_t).

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 18 Apr 2024 19:51:46 +0200

charls (2.4.2-2) unstable; urgency=medium

  * Team upload.
  * d/maintscript: Remove leftover
  * d/rules: Migrate to ninja build
  * d/control: Bump Std-Vers to 4.6.2 no changes needed

 -- Mathieu Malaterre <malat@debian.org>  Mon, 30 Oct 2023 15:56:47 +0100

charls (2.4.2-1) unstable; urgency=medium

  * Team upload.
  * d/rules: Start using LTO
  * New upstream version 2.4.2
  * d/rules: Remove old compat symlinks (oldstable)

 -- Mathieu Malaterre <malat@debian.org>  Thu, 12 Oct 2023 16:16:16 +0200
