=== debian/control ===
--- 
+++ 
@@ -1,12 +1,12 @@
 Source: charls
-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Andreas Tille <tille@debian.org>,
            Shayan Doust <hello@shayandoust.me>
 Section: science
 Priority: optional
-Build-Depends: cmake,
-               debhelper-compat (= 13)
-Standards-Version: 4.6.1
+Build-Depends: cmake, debhelper-compat (= 13), ninja-build
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/charls
 Vcs-Git: https://salsa.debian.org/med-team/charls.git
 Homepage: https://github.com/team-charls/charls
@@ -16,8 +16,7 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libcharls2 (= ${binary:Version}),
-         ${misc:Depends}
+Depends: libcharls2 (= ${binary:Version}), ${misc:Depends}
 Breaks: libdcmtk-dev (<< 3.6.5-1~)
 Replaces: libdcmtk-dev (<< 3.6.5-1~)
 Description: Implementation of the JPEG-LS standard (development libraries)
@@ -36,8 +35,7 @@
 Architecture: any
 Multi-Arch: same
 Section: libs
-Depends: ${misc:Depends},
-         ${shlibs:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Pre-Depends: ${misc:Pre-Depends}
 Description: Implementation of the JPEG-LS standard
  CharLS is an optimized implementation of the JPEG-LS standard for lossless and
